close all; clear all; clc;

%% 1. setting up a camera intrinsic matrix K
K=[500,0,320;
  0,500,240;
  0,0,1];

%% 2. setting up 4 world points that lie on Z=0 plane
X1=[0;0;0];
X2=[0;1;0];
X3=[1;1;0];
X4=[1;0;0];
X=[X1,X2,X3,X4];

%% 3. setting up camera's pose in the world frame
Rcw=rot.rodrigues([0,pi+pi/18.0,0]);
tcw=[0;0;10];

%% 4. calculate world's pose in camera frame
[Rwc,twc]=invRt(Rcw,tcw);

%% 5. perform perspective projection
U=pgProject(K,Rwc,twc,X);

%% 6. plot camera and world points
vz.newfig3d;
vz.lineloop(X);
vz.frame(eye(3),zeros(3,1),'name','world','scale',3);
vz.camera(K,Rwc,twc,640,480,'name','camera','scale',3);
trackball on;

%% 7. plot observed image points
vz.newfig2d;
vz.img(640,480);
vz.lineloop(U);