close all; clc;

%% 1. get detections and image
[ds, img]=run_apriltagfinder_cb;

% check the first homography
disp(ds(1).H);

% points on marker plane
X=[-1,-1;1,-1;1,1;-1,1]';

% project points from marker plane to image plane
U=pgInhomogenize(ds(1).H*pgHomogenize(X));

% compare the projected points with observed points
disp(U-ds.p);

%% 2. calculate H using DLT
H = pgDlt(ds.p,X);
disp(H/H(3,3));
disp(ds(1).H/ds.H(3,3));

%% 3. recover pose
[Rwc,twc]=pgKH2Rt(K,H,true);

%% 4. plot 3D coordinate from on the marker with recovered pose
Xp=[0,0,0;1,0,0;0,1,0;0,0,1]';
Up=pgProject(K,d,Rwc,twc,Xp);
imshow(img);
hold on;
AprilTagFinder.drawLines(Up,[1,2;1,3;1,4],[1,0,0;0,1,0;0,0,1]);

%% 5. do this in real-time
run_apriltagfinder_cb(gen_callback_frame(K,d));